Git 2.20.1
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
a0ef2934 45dissociate=
70c7ac22 46
be9d0a3a
HV
47die_if_unmatched ()
48{
49 if test "$1" = "#unmatched"
50 then
c4c02bf1 51 exit ${2:-1}
be9d0a3a
HV
52 fi
53}
54
88ce00c3
TK
55#
56# Print a submodule configuration setting
57#
58# $1 = submodule name
59# $2 = option name
60# $3 = default value
61#
62# Checks in the usual git-config places first (for overrides),
63# otherwise it falls back on .gitmodules. This allows you to
64# distribute project-wide defaults in .gitmodules, while still
65# customizing individual repositories if necessary. If the option is
66# not in .gitmodules either, print a default value.
67#
68get_submodule_config () {
69 name="$1"
70 option="$2"
71 default="$3"
72 value=$(git config submodule."$name"."$option")
73 if test -z "$value"
74 then
b2faad44 75 value=$(git submodule--helper config submodule."$name"."$option")
88ce00c3
TK
76 fi
77 printf '%s' "${value:-$default}"
78}
79
862ae6cd
RS
80isnumber()
81{
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83}
84
dda63468 85# Given a full hex object ID, is this the zero OID?
86is_zero_oid () {
87 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
88}
89
14111fc4
JK
90# Sanitize the local git environment for use within a submodule. We
91# can't simply use clear_local_git_env since we want to preserve some
92# of the settings from GIT_CONFIG_PARAMETERS.
93sanitize_submodule_env()
94{
89044baa 95 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 96 clear_local_git_env
89044baa 97 GIT_CONFIG_PARAMETERS=$save_config
860cba61 98 export GIT_CONFIG_PARAMETERS
14111fc4
JK
99}
100
ecda0723
SV
101#
102# Add a new submodule to the working tree, .gitmodules and the index
103#
ec05df35 104# $@ = repo path
ecda0723
SV
105#
106# optional branch is stored in global branch variable
107#
23a485e3 108cmd_add()
ecda0723 109{
5c08dbbd 110 # parse $args after "submodule ... add".
091a6eb0 111 reference_path=
5c08dbbd
JH
112 while test $# -ne 0
113 do
114 case "$1" in
115 -b | --branch)
116 case "$2" in '') usage ;; esac
117 branch=$2
118 shift
119 ;;
d27b876b
JL
120 -f | --force)
121 force=$1
122 ;;
5c08dbbd 123 -q|--quiet)
2e6a30ef 124 GIT_QUIET=1
5c08dbbd 125 ;;
6d33e1c2
CF
126 --progress)
127 progress=1
128 ;;
d92a3959
MT
129 --reference)
130 case "$2" in '') usage ;; esac
091a6eb0 131 reference_path=$2
d92a3959
MT
132 shift
133 ;;
134 --reference=*)
091a6eb0 135 reference_path="${1#--reference=}"
d92a3959 136 ;;
a0ef2934
CF
137 --dissociate)
138 dissociate=1
139 ;;
73b0898d
JL
140 --name)
141 case "$2" in '') usage ;; esac
142 custom_name=$2
143 shift
144 ;;
275cd184
FG
145 --depth)
146 case "$2" in '') usage ;; esac
147 depth="--depth=$2"
148 shift
149 ;;
150 --depth=*)
151 depth=$1
152 ;;
5c08dbbd
JH
153 --)
154 shift
155 break
156 ;;
157 -*)
158 usage
159 ;;
160 *)
161 break
162 ;;
163 esac
164 shift
165 done
166
76e9bdc4
AO
167 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
168 then
169 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
170 fi
171
091a6eb0
JK
172 if test -n "$reference_path"
173 then
174 is_absolute_path "$reference_path" ||
175 reference_path="$wt_prefix$reference_path"
176
177 reference="--reference=$reference_path"
178 fi
179
ecda0723 180 repo=$1
64394e3a 181 sm_path=$2
ecda0723 182
64394e3a 183 if test -z "$sm_path"; then
6a066230 184 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
185 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
186 fi
187
496eeeb1 188 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
189 usage
190 fi
191
091a6eb0
JK
192 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
193
ec05df35
ML
194 # assure repo is absolute or relative to parent
195 case "$repo" in
196 ./*|../*)
091a6eb0
JK
197 test -z "$wt_prefix" ||
198 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
199
ec05df35 200 # dereference source url relative to parent's url
63e95beb 201 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
202 ;;
203 *:*|/*)
204 # absolute url
205 realrepo=$repo
206 ;;
207 *)
497ee872 208 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
209 ;;
210 esac
211
db75ada5
MG
212 # normalize path:
213 # multiple //; leading ./; /./; /../; trailing /
64394e3a 214 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
215 sed -e '
216 s|//*|/|g
217 s|^\(\./\)*||
8196e728 218 s|/\(\./\)*|/|g
db75ada5
MG
219 :start
220 s|\([^/]*\)/\.\./||
221 tstart
222 s|/*$||
223 ')
619acfc7
SB
224 if test -z "$force"
225 then
226 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
227 die "$(eval_gettext "'\$sm_path' already exists in the index")"
228 else
229 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
230 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
231 fi
ecda0723 232
53213994
JK
233 if test -z "$force" &&
234 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 235 then
6ff875c5 236 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 237\$sm_path
6ff875c5 238Use -f if you really want to add it." >&2
d27b876b
JL
239 exit 1
240 fi
241
73b0898d
JL
242 if test -n "$custom_name"
243 then
244 sm_name="$custom_name"
245 else
246 sm_name="$sm_path"
247 fi
248
0383bbb9
JK
249 if ! git submodule--helper check-name "$sm_name"
250 then
251 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
252 fi
253
d4264ca3 254 # perhaps the path exists and is already a git repo, else clone it
64394e3a 255 if test -e "$sm_path"
d4264ca3 256 then
496eeeb1 257 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 258 then
64394e3a 259 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 260 else
64394e3a 261 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 262 fi
c2f93917 263
d4264ca3 264 else
4b7c286e
JL
265 if test -d ".git/modules/$sm_name"
266 then
267 if test -z "$force"
268 then
0d71dbfd 269 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 270 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
271 die "$(eval_gettextln "\
272If you want to reuse this local git directory instead of cloning again from
273 \$realrepo
274use the '--force' option. If the local git directory is not the correct repo
275or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 276 else
0d71dbfd 277 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
278 fi
279 fi
a0ef2934 280 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
d851ffb9 281 (
14111fc4 282 sanitize_submodule_env
d851ffb9
JH
283 cd "$sm_path" &&
284 # ash fails to wordsplit ${branch:+-b "$branch"...}
285 case "$branch" in
286 '') git checkout -f -q ;;
287 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
288 esac
289 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 290 fi
73b0898d 291 git config submodule."$sm_name".url "$realrepo"
d4264ca3 292
53213994 293 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 294 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 295
b2faad44
AO
296 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
297 git submodule--helper config submodule."$sm_name".url "$repo" &&
b9289227
TK
298 if test -n "$branch"
299 then
b2faad44 300 git submodule--helper config submodule."$sm_name".branch "$branch"
b9289227 301 fi &&
31991b02 302 git add --force .gitmodules ||
64394e3a 303 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
304
305 # NEEDSWORK: In a multi-working-tree world, this needs to be
306 # set in the per-worktree config.
307 if git config --get submodule.active >/dev/null
308 then
309 # If the submodule being adding isn't already covered by the
310 # current configured pathspec, set the submodule's active flag
311 if ! git submodule--helper is-active "$sm_path"
312 then
313 git config submodule."$sm_name".active "true"
314 fi
315 else
316 git config submodule."$sm_name".active "true"
317 fi
ecda0723
SV
318}
319
19a31f9c
ML
320#
321# Execute an arbitrary command sequence in each checked out
322# submodule
323#
324# $@ = command to execute
325#
326cmd_foreach()
327{
1d5bec8b
JH
328 # parse $args after "submodule ... foreach".
329 while test $# -ne 0
330 do
331 case "$1" in
332 -q|--quiet)
333 GIT_QUIET=1
334 ;;
15fc56a8
JH
335 --recursive)
336 recursive=1
337 ;;
1d5bec8b
JH
338 -*)
339 usage
340 ;;
341 *)
342 break
343 ;;
344 esac
345 shift
346 done
347
fc1b9243 348 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
19a31f9c
ML
349}
350
70c7ac22 351#
211b7f19 352# Register submodules in .git/config
70c7ac22
LH
353#
354# $@ = requested paths (default to all)
355#
23a485e3 356cmd_init()
70c7ac22 357{
5c08dbbd
JH
358 # parse $args after "submodule ... init".
359 while test $# -ne 0
360 do
361 case "$1" in
362 -q|--quiet)
2e6a30ef 363 GIT_QUIET=1
5c08dbbd
JH
364 ;;
365 --)
366 shift
367 break
368 ;;
369 -*)
370 usage
371 ;;
372 *)
373 break
374 ;;
375 esac
376 shift
377 done
378
6e7c14e6 379 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
380}
381
cf419828
JL
382#
383# Unregister submodules from .git/config and remove their work tree
384#
cf419828
JL
385cmd_deinit()
386{
387 # parse $args after "submodule ... deinit".
f6a52799 388 deinit_all=
cf419828
JL
389 while test $# -ne 0
390 do
391 case "$1" in
392 -f|--force)
393 force=$1
394 ;;
395 -q|--quiet)
396 GIT_QUIET=1
397 ;;
f6a52799
SB
398 --all)
399 deinit_all=t
400 ;;
cf419828
JL
401 --)
402 shift
403 break
404 ;;
405 -*)
406 usage
407 ;;
408 *)
409 break
410 ;;
411 esac
412 shift
413 done
414
2e612731 415 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
cf419828
JL
416}
417
fb43e31f 418is_tip_reachable () (
01e1d544 419 sanitize_submodule_env &&
fb43e31f
SB
420 cd "$1" &&
421 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
422 test -z "$rev"
423)
424
425fetch_in_submodule () (
01e1d544 426 sanitize_submodule_env &&
fb43e31f
SB
427 cd "$1" &&
428 case "$2" in
429 '')
430 git fetch ;;
431 *)
6cbf454a
SB
432 shift
433 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
434 esac
435)
436
70c7ac22 437#
211b7f19 438# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
439#
440# $@ = requested paths (default to all)
441#
23a485e3 442cmd_update()
70c7ac22 443{
5c08dbbd
JH
444 # parse $args after "submodule ... update".
445 while test $# -ne 0
446 do
447 case "$1" in
448 -q|--quiet)
2e6a30ef 449 GIT_QUIET=1
5c08dbbd 450 ;;
e84c3cf3
SB
451 -v)
452 GIT_QUIET=0
453 ;;
72c5f883 454 --progress)
c7199e3a 455 progress=1
72c5f883 456 ;;
be4d2c83 457 -i|--init)
d92a3959 458 init=1
be4d2c83 459 ;;
06b1abb5
TK
460 --remote)
461 remote=1
462 ;;
31ca3ac3 463 -N|--no-fetch)
31ca3ac3
FF
464 nofetch=1
465 ;;
9db31bdf
NMC
466 -f|--force)
467 force=$1
468 ;;
ca2cedba 469 -r|--rebase)
32948425 470 update="rebase"
ca2cedba 471 ;;
d92a3959
MT
472 --reference)
473 case "$2" in '') usage ;; esac
474 reference="--reference=$2"
98dbe63d 475 shift
d92a3959
MT
476 ;;
477 --reference=*)
478 reference="$1"
d92a3959 479 ;;
a0ef2934
CF
480 --dissociate)
481 dissociate=1
482 ;;
42b49178 483 -m|--merge)
42b49178
JH
484 update="merge"
485 ;;
b13fd5c1 486 --recursive)
b13fd5c1
JH
487 recursive=1
488 ;;
efc5fb6a
JH
489 --checkout)
490 update="checkout"
491 ;;
abed000a
SB
492 --recommend-shallow)
493 recommend_shallow="--recommend-shallow"
494 ;;
495 --no-recommend-shallow)
496 recommend_shallow="--no-recommend-shallow"
497 ;;
275cd184
FG
498 --depth)
499 case "$2" in '') usage ;; esac
500 depth="--depth=$2"
501 shift
502 ;;
503 --depth=*)
504 depth=$1
505 ;;
2335b870
SB
506 -j|--jobs)
507 case "$2" in '') usage ;; esac
508 jobs="--jobs=$2"
509 shift
510 ;;
511 --jobs=*)
512 jobs=$1
513 ;;
5c08dbbd
JH
514 --)
515 shift
516 break
517 ;;
518 -*)
519 usage
520 ;;
521 *)
522 break
523 ;;
524 esac
98dbe63d 525 shift
5c08dbbd
JH
526 done
527
d92a3959
MT
528 if test -n "$init"
529 then
530 cmd_init "--" "$@" || return
531 fi
532
48308681
SB
533 {
534 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 535 ${progress:+"--progress"} \
48308681
SB
536 ${wt_prefix:+--prefix "$wt_prefix"} \
537 ${prefix:+--recursive-prefix "$prefix"} \
538 ${update:+--update "$update"} \
5f50f33e 539 ${reference:+"$reference"} \
a0ef2934 540 ${dissociate:+"--dissociate"} \
48308681 541 ${depth:+--depth "$depth"} \
c7199e3a
CF
542 $recommend_shallow \
543 $jobs \
c4c02bf1 544 "$@" || echo "#unmatched" $?
48308681 545 } | {
15ffb7cd 546 err=
9eca701f 547 while read -r quickabort sha1 just_cloned sm_path
70c7ac22 548 do
9eca701f 549 die_if_unmatched "$quickabort" "$sha1"
48308681 550
74d4731d
SB
551 git submodule--helper ensure-core-worktree "$sm_path"
552
ee69b2a9 553 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
efc5fb6a 554
44431df0 555 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 556
48308681 557 if test $just_cloned -eq 1
d851ffb9 558 then
bf2d8246
LH
559 subsha1=
560 else
14111fc4 561 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 562 git rev-parse --verify HEAD) ||
091a6eb0 563 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 564 fi
211b7f19 565
06b1abb5
TK
566 if test -n "$remote"
567 then
92bbe7cc 568 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
569 if test -z "$nofetch"
570 then
571 # Fetch remote before determining tracking $sha1
6cbf454a 572 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
573 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
574 fi
14111fc4
JK
575 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
576 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 577 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 578 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
579 fi
580
496eeeb1 581 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 582 then
9db31bdf
NMC
583 subforce=$force
584 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 585 if test -z "$subsha1" && test -z "$force"
b9b378a0 586 then
9db31bdf 587 subforce="-f"
b9b378a0 588 fi
31ca3ac3
FF
589
590 if test -z "$nofetch"
591 then
e5f522d6
JL
592 # Run fetch only if $sha1 isn't present or it
593 # is not reachable from a ref.
fb43e31f 594 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 595 fetch_in_submodule "$sm_path" $depth ||
e30d8336 596 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
597
598 # Now we tried the usual fetch, but $sha1 may
599 # not be reachable from any of the refs
600 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 601 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 602 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
603 fi
604
877449c1 605 must_die_on_failure=
32948425 606 case "$update_module" in
a2aed08b
TK
607 checkout)
608 command="git checkout $subforce -q"
609 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
610 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
611 ;;
32948425
JH
612 rebase)
613 command="git rebase"
091a6eb0
JK
614 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
615 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 616 must_die_on_failure=yes
32948425 617 ;;
42b49178
JH
618 merge)
619 command="git merge"
091a6eb0
JK
620 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
621 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 622 must_die_on_failure=yes
42b49178 623 ;;
6cb5728c
CP
624 !*)
625 command="${update_module#!}"
b08238ac
SB
626 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
627 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
628 must_die_on_failure=yes
629 ;;
32948425 630 *)
ff03d930 631 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
32948425 632 esac
70c7ac22 633
14111fc4 634 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 635 then
ff968f03 636 say "$say_msg"
877449c1
JH
637 elif test -n "$must_die_on_failure"
638 then
ff968f03 639 die_with_status 2 "$die_msg"
15ffb7cd 640 else
ff968f03 641 err="${err};$die_msg"
877449c1 642 continue
15ffb7cd 643 fi
70c7ac22 644 fi
b13fd5c1
JH
645
646 if test -n "$recursive"
647 then
75bf5e60 648 (
44431df0 649 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 650 wt_prefix=
14111fc4 651 sanitize_submodule_env
75bf5e60 652 cd "$sm_path" &&
36141282 653 eval cmd_update
75bf5e60 654 )
15ffb7cd
FG
655 res=$?
656 if test $res -gt 0
657 then
091a6eb0 658 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 659 if test $res -ne 2
15ffb7cd 660 then
ff968f03 661 err="${err};$die_msg"
15ffb7cd
FG
662 continue
663 else
ff968f03 664 die_with_status $res "$die_msg"
15ffb7cd
FG
665 fi
666 fi
b13fd5c1 667 fi
70c7ac22 668 done
15ffb7cd
FG
669
670 if test -n "$err"
671 then
672 OIFS=$IFS
673 IFS=';'
674 for e in $err
675 do
676 if test -n "$e"
677 then
678 echo >&2 "$e"
679 fi
680 done
681 IFS=$OIFS
682 exit 1
683 fi
684 }
70c7ac22
LH
685}
686
28f9af5d
PY
687#
688# Show commit summary for submodules in index or working tree
689#
690# If '--cached' is given, show summary between index and given commit,
691# or between working tree and given commit
692#
693# $@ = [commit (default 'HEAD'),] requested paths (default all)
694#
695cmd_summary() {
f2dc06a3 696 summary_limit=-1
d0f64dd4 697 for_status=
1c244f6e 698 diff_cmd=diff-index
f2dc06a3 699
28f9af5d
PY
700 # parse $args after "submodule ... summary".
701 while test $# -ne 0
702 do
703 case "$1" in
704 --cached)
705 cached="$1"
706 ;;
1c244f6e
JL
707 --files)
708 files="$1"
709 ;;
d0f64dd4
PY
710 --for-status)
711 for_status="$1"
712 ;;
f2dc06a3 713 -n|--summary-limit)
862ae6cd
RS
714 summary_limit="$2"
715 isnumber "$summary_limit" || usage
f2dc06a3
PY
716 shift
717 ;;
862ae6cd
RS
718 --summary-limit=*)
719 summary_limit="${1#--summary-limit=}"
720 isnumber "$summary_limit" || usage
721 ;;
28f9af5d
PY
722 --)
723 shift
724 break
725 ;;
726 -*)
727 usage
728 ;;
729 *)
730 break
731 ;;
732 esac
733 shift
734 done
bffe71f4 735
f2dc06a3
PY
736 test $summary_limit = 0 && return
737
3deea89c 738 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
739 then
740 head=$rev
caa9c3ca 741 test $# = 0 || shift
496eeeb1 742 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 743 then
14e940d7
JH
744 # before the first commit: compare with an empty tree
745 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 746 test -z "$1" || shift
28f9af5d 747 else
3deea89c 748 head="HEAD"
28f9af5d
PY
749 fi
750
1c244f6e
JL
751 if [ -n "$files" ]
752 then
753 test -n "$cached" &&
465d6a00 754 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
755 diff_cmd=diff-files
756 head=
757 fi
758
28f9af5d 759 cd_to_toplevel
091a6eb0 760 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 761 # Get modified modules cared by user
18076502 762 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 763 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 764 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
765 do
766 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
767 if test "$status" = D || test "$status" = T
768 then
6a066230 769 printf '%s\n' "$sm_path"
496eeeb1
EP
770 continue
771 fi
927b26f8 772 # Respect the ignore setting for --for-status.
773 if test -n "$for_status"
774 then
0ea306ef 775 name=$(git submodule--helper name "$sm_path")
927b26f8 776 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 777 test $status != A && test $ignore_config = all && continue
927b26f8 778 fi
28f9af5d 779 # Also show added or modified modules which are checked out
974ce807 780 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 781 printf '%s\n' "$sm_path"
28f9af5d
PY
782 done
783 )
1cb639e6 784
d0f64dd4
PY
785 test -z "$modules" && return
786
18076502 787 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 788 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 789 cut -c2- |
cf9e55f4 790 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
791 do
792 if test -z "$cached" &&
dda63468 793 is_zero_oid $sha1_dst
1cb639e6
PY
794 then
795 case "$mod_dst" in
796 160000)
797 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
798 ;;
799 100644 | 100755 | 120000)
800 sha1_dst=$(git hash-object $name)
801 ;;
802 000000)
803 ;; # removed
804 *)
805 # unexpected type
6ff875c5 806 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
807 continue ;;
808 esac
809 fi
810 missing_src=
811 missing_dst=
812
813 test $mod_src = 160000 &&
974ce807 814 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
815 missing_src=t
816
817 test $mod_dst = 160000 &&
974ce807 818 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 819 missing_dst=t
bffe71f4 820
44431df0 821 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 822
1cb639e6
PY
823 total_commits=
824 case "$missing_src,$missing_dst" in
825 t,)
091a6eb0 826 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
827 ;;
828 ,t)
091a6eb0 829 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
830 ;;
831 t,t)
091a6eb0 832 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
833 ;;
834 *)
835 errmsg=
836 total_commits=$(
496eeeb1 837 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
838 then
839 range="$sha1_src...$sha1_dst"
840 elif test $mod_src = 160000
841 then
842 range=$sha1_src
843 else
844 range=$sha1_dst
845 fi
846 GIT_DIR="$name/.git" \
b0e621ad 847 git rev-list --first-parent $range -- | wc -l
1cb639e6 848 )
eed35595 849 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
850 ;;
851 esac
852
853 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
854 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
855 if test $status = T
856 then
b3e73449
ÆAB
857 blob="$(gettext "blob")"
858 submodule="$(gettext "submodule")"
1cb639e6
PY
859 if test $mod_dst = 160000
860 then
091a6eb0 861 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 862 else
091a6eb0 863 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
864 fi
865 else
091a6eb0 866 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
867 fi
868 if test -n "$errmsg"
869 then
870 # Don't give error msg for modification whose dst is not submodule
871 # i.e. deleted or changed to blob
872 test $mod_dst = 160000 && echo "$errmsg"
873 else
496eeeb1 874 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 875 then
f2dc06a3
PY
876 limit=
877 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 878 GIT_DIR="$name/.git" \
f2dc06a3 879 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
880 --first-parent $sha1_src...$sha1_dst
881 elif test $mod_dst = 160000
882 then
883 GIT_DIR="$name/.git" \
884 git log --pretty='format: > %s' -1 $sha1_dst
885 else
886 GIT_DIR="$name/.git" \
887 git log --pretty='format: < %s' -1 $sha1_src
888 fi
889 echo
890 fi
891 echo
3ba7407b 892 done
28f9af5d 893}
70c7ac22 894#
941987a5 895# List all submodules, prefixed with:
70c7ac22
LH
896# - submodule not initialized
897# + different revision checked out
898#
899# If --cached was specified the revision in the index will be printed
900# instead of the currently checked out revision.
901#
902# $@ = requested paths (default to all)
903#
23a485e3 904cmd_status()
70c7ac22 905{
5c08dbbd
JH
906 # parse $args after "submodule ... status".
907 while test $# -ne 0
908 do
909 case "$1" in
910 -q|--quiet)
2e6a30ef 911 GIT_QUIET=1
5c08dbbd
JH
912 ;;
913 --cached)
914 cached=1
915 ;;
64b19ffe
JH
916 --recursive)
917 recursive=1
918 ;;
5c08dbbd
JH
919 --)
920 shift
921 break
922 ;;
923 -*)
924 usage
925 ;;
926 *)
927 break
928 ;;
929 esac
930 shift
931 done
932
a9f8a375 933 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
70c7ac22 934}
2327f61e
DA
935#
936# Sync remote urls for submodules
937# This makes the value for remote.$remote.url match the value
938# specified in .gitmodules.
939#
940cmd_sync()
941{
942 while test $# -ne 0
943 do
944 case "$1" in
945 -q|--quiet)
2e6a30ef 946 GIT_QUIET=1
2327f61e
DA
947 shift
948 ;;
82f49f29
PH
949 --recursive)
950 recursive=1
951 shift
952 ;;
2327f61e
DA
953 --)
954 shift
955 break
956 ;;
957 -*)
958 usage
959 ;;
960 *)
961 break
962 ;;
963 esac
964 done
e7849a96 965
13424764 966 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
2327f61e 967}
70c7ac22 968
f6f85861
SB
969cmd_absorbgitdirs()
970{
971 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
972}
973
5c08dbbd
JH
974# This loop parses the command line arguments to find the
975# subcommand name to dispatch. Parsing of the subcommand specific
976# options are primarily done by the subcommand implementations.
977# Subcommand specific options such as --branch and --cached are
978# parsed here as well, for backward compatibility.
979
980while test $# != 0 && test -z "$command"
70c7ac22
LH
981do
982 case "$1" in
f6f85861 983 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 984 command=$1
70c7ac22
LH
985 ;;
986 -q|--quiet)
2e6a30ef 987 GIT_QUIET=1
70c7ac22 988 ;;
ecda0723
SV
989 -b|--branch)
990 case "$2" in
991 '')
992 usage
993 ;;
994 esac
995 branch="$2"; shift
996 ;;
70c7ac22 997 --cached)
28f9af5d 998 cached="$1"
70c7ac22
LH
999 ;;
1000 --)
1001 break
1002 ;;
1003 -*)
1004 usage
1005 ;;
1006 *)
1007 break
1008 ;;
1009 esac
1010 shift
1011done
1012
5c08dbbd 1013# No command word defaults to "status"
af9c9f97
RR
1014if test -z "$command"
1015then
1016 if test $# = 0
1017 then
1018 command=status
1019 else
1020 usage
1021 fi
1022fi
5c08dbbd
JH
1023
1024# "-b branch" is accepted only by "add"
1025if test -n "$branch" && test "$command" != add
1026then
ecda0723 1027 usage
5c08dbbd
JH
1028fi
1029
28f9af5d 1030# "--cached" is accepted only by "status" and "summary"
496eeeb1 1031if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1032then
70c7ac22 1033 usage
5c08dbbd
JH
1034fi
1035
1036"cmd_$command" "$@"